package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;
import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.cls.*;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

//public class EditDialog extends JDialog implements ActionListener

public class EditDialog extends JFrame
{
	JButton okButton, cancelButton;
	NCIEditTab tab;
	EditPanel editpanel;
	Cls cls;

	public EditDialog(NCIEditTab tab, Cls cls){
		//super((JFrame)tab.getTopLevelAncestor(), cls.getBrowserText(), false);
		this.tab = tab;
		this.cls = cls;
		this.setTitle(cls.getBrowserText());
		init();
	}

	public void init()
	{
		Container container = this.getContentPane();
		setLocation(250,150);
		setSize(new Dimension(800,550));
		container.setLayout(new BorderLayout());

        editpanel = tab.createEditPanel(cls);
        editpanel.setFocusClass((OWLNamedClass) cls);
        editpanel.disableAll();
        container.add(editpanel, BorderLayout.NORTH);
        this.toFront();
		this.setVisible(true);


		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent event) {
				if (tab.getEditPanel() != null && tab.getEditPanel().getFocusClass() != null)
				{
					OWLNamedClass focusedCls = tab.getEditPanel().getFocusClass();
					if (focusedCls.getBrowserText().compareTo(cls.getBrowserText()) != 0)
					{
						tab.removeFromListenedToClses((OWLNamedClass) cls);
					}
				}
				setVisible(false);
			}
		});

   	}
}
