package gov.nih.nci.protegex.edit;

import javax.swing.JTree;
import java.awt.Color;
import java.awt.Component;
import javax.swing.tree.DefaultTreeCellRenderer;


import javax.swing.tree.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.basic.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */


public class TreeRenderer extends DefaultTreeCellRenderer
{
	 public Component getTreeCellRendererComponent(JTree tree, Object value, boolean isSelected,
	 				boolean expanded, boolean leaf, int row, boolean hasFocus)
	 {
	 	 TreeNode node = (TreeNode)value;
		 if (isSelected)
		 	setForeground(Color.white);
		 else
		 	setForeground(node.getColor());
		 setText(node.getText());
		 setIcon(node.getIcon());
		 selected = isSelected;
		 return this;
     }
}
